=== tools/precommit/requirements.txt ===
appdirs==1.4.4
attrs==20.1.0
black==19.10b0
click==7.1.2
Flask==1.1.2
gunicorn==20.0.4
itsdangerous==1.1.0
Jinja2==2.11.2
MarkupSafe==1.1.1
pathspec==0.8.0
regex==2020.7.14
toml==0.10.1
typed-ast==1.4.1
Werkzeug==1.0.1
