=== debian/changelog ===
cp2k (8.1-9) unstable; urgency=medium

  * debian/cp2k.links: Switch link targets to psmp (Closes: #985519).

 -- Michael Banck <mbanck@debian.org>  Tue, 23 Mar 2021 09:02:52 +0100

cp2k (8.1-8) unstable; urgency=medium

  * debian/rules (override_dh_auto_test): Fail build if tests fail.
  * debian/tests/control: Add libint2-2 Depends on version 2.6.0-11.

 -- Michael Banck <mbanck@debian.org>  Thu, 18 Feb 2021 23:03:35 +0100

cp2k (8.1-7) unstable; urgency=medium

  * debian/control (Build-Depends): Bump libint2-dev version to 2.6.0-11
    (Closes: #982172).

 -- Michael Banck <mbanck@debian.org>  Tue, 16 Feb 2021 13:30:35 +0100

cp2k (8.1-6) unstable; urgency=medium

  * debian/patches/makeflags.patch: Add -lstdc++ to LIBS. 
  * debian/rules (Build-Depends): Bump libint2-dev version to 2.6.0-9.
  * debian/rules: Remove NO_LIBINT_ARCHS machinery.

 -- Michael Banck <mbanck@debian.org>  Sat, 30 Jan 2021 23:12:58 +0100

cp2k (8.1-5) unstable; urgency=medium

  * debian/control (Build-Depends): Revert changes from commit 76f7e1b4.

 -- Michael Banck <mbanck@debian.org>  Wed, 06 Jan 2021 15:24:59 +0100

cp2k (8.1-4) unstable; urgency=medium

  * debian/control (Build-Depends): Revert accidental local changes from last
    upload.

 -- Michael Banck <mbanck@debian.org>  Wed, 06 Jan 2021 14:32:55 +0100

cp2k (8.1-3) unstable; urgency=medium

  * debian/patches/makeflags.patch: Use mpif90 instead of gfortran as linker
    for the popt and psmp versions.

 -- Michael Banck <mbanck@debian.org>  Wed, 06 Jan 2021 12:28:27 +0100

cp2k (8.1-2) unstable; urgency=medium

  * debian/patches/makeflags.patch: Readd -fallow-argument-mismatch to FCFLAGS
    in order to fix build failures on 32bit architectures.

 -- Michael Banck <mbanck@debian.org>  Thu, 31 Dec 2020 18:26:09 +0100

cp2k (8.1-1) unstable; urgency=medium

  * New upstream release.
   + RI-HFX: Add resolution of identity for Hartree-Fock exchange
   + ALMO: Add trust region methods
   + Linear Scaling DFT: New implementation based on the submatrix method and
     matrix sign function
   + TDDFPT code refactoring, add sTDA kernel, xTB/sTDA method
   + Response code for polarizabilities: add finite difference debug, hybrid
     functionals, and ADMM
   + Harris functional based on Kohn-Sham density
   + NNP: Behler-Parrinello Neural Network Potentials
   + XAS_TDP: Add OT solver and improve performance
   + mGGA: Add stress tensor
  * debian/patches/python3.patch: Removed, no longer needed.
  * debian/patches/dbcsr_gfortran10.patch: Likewise.
  * debian/patches/gfortran10.patch: Likewise.
  * debian/patches/testsuite_output.patch: Refreshed.
  * debian/patches/makeflags.patch: Add CFLAGS variable, defining now required
    -fopenmp, add -fopenmp to FCFLAGS and drop -fallow-argument-mismatch from
    it.
  * debian/rules (override_dh_auto_test): Add one more regtest directory.

 -- Michael Banck <mbanck@debian.org>  Thu, 31 Dec 2020 14:12:29 +0100
