=== debian/watch ===
version=3
https://github.com/cp2k/cp2k/releases .*/releases/download/v[\d.]+/cp2k-([\d.]+)\.tar\.(?:bz2|gz)
